## zlmdb 22.1.2

=== Makefile ===
.PHONY: clean clean-docs clean-test clean-pyc clean-build docs help
.DEFAULT_GOAL := help

define BROWSER_PYSCRIPT
import os, webbrowser, sys

try:
	from urllib import pathname2url
except:
	from urllib.request import pathname2url

webbrowser.open("file://" + pathname2url(os.path.abspath(sys.argv[1])))
endef
export BROWSER_PYSCRIPT

define PRINT_HELP_PYSCRIPT
import re, sys

for line in sys.stdin:
	match = re.match(r'^([a-zA-Z_-]+):.*?## (.*)$$', line)
	if match:
		target, help = match.groups()
		print("%-20s %s" % (target, help))
endef
export PRINT_HELP_PYSCRIPT

BROWSER := python -c "$$BROWSER_PYSCRIPT"

help:
	@python -c "$$PRINT_HELP_PYSCRIPT" < $(MAKEFILE_LIST)

clean: clean-build clean-pyc clean-test clean-docs ## remove all build, test, coverage, Python artifacts and docs

clean-docs:
	rm -fr docs/_build

clean-build: ## remove build artifacts
	rm -fr build/
	rm -fr dist/
	rm -fr .eggs/
	find . -name '*.egg-info' -exec rm -fr {} +
	find . -name '*.egg' -exec rm -f {} +

clean-pyc: ## remove Python file artifacts
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	find . -name '__pycache__' -exec rm -fr {} +

clean-test: ## remove test and coverage artifacts
	rm -fr .tox/
	rm -f .coverage
	rm -f .coverage.*
	rm -fr htmlcov/
	rm -fr .pytest_cache
	-rm -rf .test*
	-rm -rf .mypy_cache

lint: ## check style with flake8
	flake8 zlmdb tests

test-single:
	clear && pytest -v -s zlmdb/tests/test_basic.py

test-pmaps:
	clear && pytest -v -s zlmdb/tests/test_pmaps.py

test-indexes:
	clear && pytest -v -s zlmdb/tests/test_pmap_indexes.py

test-select:
	clear && pytest -v -s zlmdb/tests/test_select.py

#
# test ZLMDB high level API
#
test-zdb: test-zdb-etcd test-zdb-df test-zdb-dyn

test-zdb-etcd:
	python tests/zdb/test_zdb_etcd.py

test-zdb-df:
	python tests/zdb/test_zdb_df.py

test-zdb-dyn:
	python tests/zdb/test_zdb_dyn.py

test-zdb-fbs:
	python tests/zdb/test_zdb_fbs.py


test-quick:
	pytest

test:
	tox -e py36,flake8,coverage,mypy,yapf,sphinx

test-all:
	tox

coverage: ## check code coverage quickly with the default Python
	#coverage run --source zlmdb -m pytest
	coverage run --source zlmdb --omit="zlmdb/flatbuffer/reflection/*,zlmdb/flatbuffer/demo/*,zlmdb/tests/*" -m pytest -v -s zlmdb
	coverage report -m
	coverage html
	$(BROWSER) htmlcov/index.html

docs: ## generate Sphinx HTML documentation, including API docs
	sphinx-build -b html ./docs ./docs/_build
	$(BROWSER) docs/_build/index.html

dist: clean ## builds source and wheel package
	python setup.py sdist bdist_wheel
	ls -la dist
	unzip -l dist/zlmdb-*-py2.py3-none-any.whl

# publish to PyPI
publish: dist
	twine upload dist/*

install:
	-pip uninstall -y pytest_asyncio # remove the broken shit
	-pip uninstall -y pytest_cov # remove the broken shit
	pip install -e .
	pip install -r requirements-dev.txt

yapf:
	yapf --version
	yapf -rd --style=yapf.ini --exclude="zlmdb/flatbuffers/*" --exclude="zlmdb/tests/MNodeLog.py" zlmdb

# auto-format code - WARNING: this my change files, in-place!
autoformat:
	yapf -ri --style=yapf.ini --exclude="zlmdb/flatbuffers/*" zlmdb


FLATC=${HOME}/scm/3rdparty/flatbuffers/flatc
#FLATC=/usr/local/bin/flatc

update_flatbuffers:
	git submodule foreach git pull
	rm -rf ./flatbuffers
	cp -R deps/flatbuffers/python/flatbuffers .

generate_flatbuffers_reflection:
	$(FLATC) --python -o zlmdb/flatbuffers/ deps/flatbuffers/reflection/reflection.fbs

generate_flatbuffers_demos:
	$(FLATC) --python -o zlmdb/flatbuffers/ zlmdb/flatbuffers/demo1.fbs
	$(FLATC) --python -o zlmdb/flatbuffers/ zlmdb/flatbuffers/demo2.fbs

# input .fbs files for schema
FBS_FILES=deps/flatbuffers/reflection/reflection.fbs
FBS_OUTPUT=./crossbarfx/master/database/

# flatc compiler to use (build directly from master: https://github.com/google/flatbuffers)
# oberstet@thinkpad-t430s:~$ which flatc
# /usr/local/bin/flatc
# oberstet@thinkpad-t430s:~$ flatc --version
# flatc version 1.9.0 (Jun 21 2018 14:06:19)
# oberstet@thinkpad-t430s:~$ flatc --help | grep builtin
#   --bfbs-builtins    Add builtin attributes to the binary schema files.
# oberstet@thinkpad-t430s:~$

flatc_version:
	$(FLATC) --version

build_fbs: build_fbs_bfbs build_fbs_python

# generate schema type library (.bfbs binary) from schema files
build_fbs_bfbs:
	$(FLATC) -o $(FBS_OUTPUT) --binary --schema --bfbs-comments --bfbs-builtins $(FBS_FILES)

# generate python bindings from schema files
build_fbs_python:
	$(FLATC) -o $(FBS_OUTPUT) --python $(FBS_FILES)


# deps/flatbuffers/flatc
# deps/flatbuffers/libflatbuffers.a
# deps/flatbuffers/include/
flatbuffers_library:
	cd deps/flatbuffers && cmake -DCMAKE_BUILD_TYPE=Release . && make && make test && cd ../..


# load_fbs(repo_oid, source_name, source_code) -> BFBS -> return UUID

# parser()
# parser.parse_from_fbs(source_name: str, source_code: str, include_dirs=[]: List[str])
# parser.serialize_to_bfbs -> bytes
# parser.conforms_to(other_parser)

# // Checks that the schema represented by this parser is a safe evolution
# // of the schema provided. Returns non-empty error on any problems.

# JSON parsing 	Yes 	No 	No 	No 	No 	No 	No 	Yes 	No 	No 	No
# Simple mutation 	Yes 	Yes 	Yes 	Yes 	No 	No 	No 	No 	No 	No 	No
# Reflection 	Yes 	No 	No 	No 	No 	No 	No 	Basic 	No 	No 	No
# Buffer verifier

=== debian/changelog ===
zlmdb (22.1.2-1) unstable; urgency=medium

  * Correct copyright year according to ftpmaster
  * New upstream version 22.1.2
  * Keep flatbuffers out of the package (Closes: #1005329)

 -- Bastian Germann <bage@debian.org>  Fri, 11 Feb 2022 13:49:21 +0100

zlmdb (21.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #1002911)

 -- Bastian Germann <bage@debian.org>  Fri, 31 Dec 2021 17:08:29 +0100

=== debian/control ===
Source: zlmdb
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Bastian Germann <bage@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-all:any,
 python3-cbor2,
 python3-cffi,
 python3-click,
 python3-flatbuffers,
 python3-lmdb,
 python3-nacl,
 python3-numpy,
 python3-pytest-runner,
 python3-txaio,
 python3-yaml
Standards-Version: 4.6.0
Homepage: https://github.com/crossbario/zlmdb
Vcs-Browser: https://salsa.debian.org/python-team/packages/zlmdb
Vcs-Git: https://salsa.debian.org/python-team/packages/zlmdb.git
Rules-Requires-Root: no

Package: python3-zlmdb
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: Object-relational in-memory database layer based on LMDB
 This object-relational in-memory database layer is based on LMDB.
 It is highly performant, supports multiple serializers,
 Apache Arrow ex-/import, native Numpy arrays, and Pandas data frames.
 ZLMDB features automatic indexes.
 .
 This package installs the library for Python 3.

## zlmdb 22.3.1

=== debian/changelog ===
zlmdb (22.3.1-1) unstable; urgency=medium

  * New upstream version 22.3.1

 -- Bastian Germann <bage@debian.org>  Mon, 28 Mar 2022 15:15:08 +0200

zlmdb (22.2.1-1) unstable; urgency=medium

  * New upstream version 22.2.1

 -- Bastian Germann <bage@debian.org>  Sun, 27 Feb 2022 13:28:33 +0100

## zlmdb 22.4.1

=== debian/changelog ===
zlmdb (22.4.1-1) unstable; urgency=medium

  * New upstream version 22.4.1

 -- Bastian Germann <bage@debian.org>  Sat, 07 May 2022 11:07:02 +0200

## zlmdb 22.5.1

=== debian/changelog ===
zlmdb (22.5.1-1) unstable; urgency=medium

  * New upstream version 22.5.1
  * d/copyright: Update for new version

 -- Bastian Germann <bage@debian.org>  Sun, 05 Jun 2022 00:02:16 +0200

## zlmdb 22.6.1

=== Makefile ===
.PHONY: clean clean-docs clean-test clean-pyc clean-build docs help
.DEFAULT_GOAL := help

define BROWSER_PYSCRIPT
import os, webbrowser, sys

try:
	from urllib import pathname2url
except:
	from urllib.request import pathname2url

webbrowser.open("file://" + pathname2url(os.path.abspath(sys.argv[1])))
endef
export BROWSER_PYSCRIPT

define PRINT_HELP_PYSCRIPT
import re, sys

for line in sys.stdin:
	match = re.match(r'^([a-zA-Z_-]+):.*?## (.*)$$', line)
	if match:
		target, help = match.groups()
		print("%-20s %s" % (target, help))
endef
export PRINT_HELP_PYSCRIPT

BROWSER := python -c "$$BROWSER_PYSCRIPT"

help:
	@python -c "$$PRINT_HELP_PYSCRIPT" < $(MAKEFILE_LIST)

clean: clean_build clean_pyc clean_test clean_docs ## remove all build, test, coverage, Python artifacts and docs

clean_docs:
	rm -fr docs/_build

clean_build: ## remove build artifacts
	rm -fr build/
	rm -fr dist/
	rm -fr .eggs/
	find . -name '*.egg-info' -exec rm -fr {} +
	find . -name '*.egg' -exec rm -f {} +

clean_pyc: ## remove Python file artifacts
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	find . -name '__pycache__' -exec rm -fr {} +

clean_test: ## remove test and coverage artifacts
	rm -fr .tox/
	rm -f .coverage
	rm -f .coverage.*
	rm -fr htmlcov/
	rm -fr .pytest_cache
	-rm -rf .test*
	-rm -rf .mypy_cache

lint: ## check style with flake8
	flake8 zlmdb tests

test_single:
	clear && pytest -v -s zlmdb/tests/test_basic.py

test_pmaps:
	clear && pytest -v -s zlmdb/tests/test_pmaps.py

test_indexes:
	clear && pytest -v -s zlmdb/tests/test_pmap_indexes.py

test_select:
	clear && pytest -v -s zlmdb/tests/test_select.py

#
# test ZLMDB high level API
#
test_zdb: test-zdb-etcd test-zdb-df test-zdb-dyn

test_zdb_etcd:
	python tests/zdb/test_zdb_etcd.py

test_zdb_df:
	python tests/zdb/test_zdb_df.py

test_zdb_dyn:
	python tests/zdb/test_zdb_dyn.py

test_zdb_fbs:
	python tests/zdb/test_zdb_fbs.py


test_quick:
	pytest

test:
	tox -e py36,flake8,coverage,mypy,yapf,sphinx

test_all:
	tox

coverage: ## check code coverage quickly with the default Python
	#coverage run --source zlmdb -m pytest
	coverage run --source zlmdb --omit="zlmdb/flatbuffer/reflection/*,zlmdb/flatbuffer/demo/*,zlmdb/tests/*" -m pytest -v -s zlmdb
	coverage report -m
	coverage html
	$(BROWSER) htmlcov/index.html

docs: ## generate Sphinx HTML documentation, including API docs
	sphinx-build -b html ./docs ./docs/_build
	$(BROWSER) docs/_build/index.html

dist: clean ## builds source and wheel package
	python setup.py sdist bdist_wheel
	ls -la dist
	unzip -l dist/zlmdb-*-py2.py3-none-any.whl

# publish to PyPI
publish: dist
	twine upload dist/*

install:
	-pip uninstall -y pytest_asyncio # remove the broken shit
	-pip uninstall -y pytest_cov # remove the broken shit
	pip install -e .
	pip install -r requirements-dev.txt

yapf:
	yapf --version
	yapf -rd --style=yapf.ini --exclude="zlmdb/flatbuffers/*" --exclude="zlmdb/tests/MNodeLog.py" zlmdb

# auto-format code - WARNING: this my change files, in-place!
autoformat:
	yapf -ri --style=yapf.ini --exclude="zlmdb/flatbuffers/*" zlmdb


FLATC=/usr/local/bin/flatc

# git submodule update --init --recursive
# git submodule update --remote --merge
# git submodule foreach git pull
update_flatbuffers:
	rm -rf ./flatbuffers
	cp -R deps/flatbuffers/python/flatbuffers .

generate_flatbuffers_reflection:
	$(FLATC) --python -o zlmdb/flatbuffers/ deps/flatbuffers/reflection/reflection.fbs

=== debian/changelog ===
zlmdb (22.6.1-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Mon, 31 Oct 2022 17:59:28 +0000

zlmdb (22.6.1-2) unstable; urgency=medium

  * Patch: Make sure PyYAML 6 can be used (Closes: #1022089)

 -- Bastian Germann <bage@debian.org>  Thu, 27 Oct 2022 20:57:56 +0200

zlmdb (22.6.1-1) unstable; urgency=medium

  * New upstream version 22.6.1

 -- Bastian Germann <bage@debian.org>  Mon, 11 Jul 2022 13:11:43 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  python3-pytest-runner,
  python3-txaio,
  python3-yaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/crossbario/zlmdb
 Vcs-Browser: https://salsa.debian.org/python-team/packages/zlmdb
 Vcs-Git: https://salsa.debian.org/python-team/packages/zlmdb.git

## zlmdb 23.1.1

=== Makefile ===
--- 
+++ 
@@ -144,3 +144,6 @@
 
 generate_flatbuffers_reflection:
 	$(FLATC) --python -o zlmdb/flatbuffers/ deps/flatbuffers/reflection/reflection.fbs
+
+fix_copyright:
+	find . -type f -exec sed -i 's/Copyright (c) Crossbar.io Technologies GmbH/Copyright (c) typedef int GmbH/g' {} \;

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = zlmdb
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== tests/Makefile ===
generate:
	~/scm/3rdparty/flatbuffers/flatc --python -o _gen user.fbs

=== debian/changelog ===
zlmdb (23.1.1-1) unstable; urgency=medium

  * Team upload
  * Drop Bastian from Uploaders

  [ Marcos Souza ]
  * New upstream version 23.1.1
  * Drop patch already applied by upstream
    - Make-sure-PyYAML-6-can-be-used.patch
  * d/copyright: Update copyright

 -- Marcos Souza <marcosfas.dev@gmail.com>  Sun, 22 Jun 2025 01:22:33 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: python
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders: Bastian Germann <bage@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dh-python,

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=zlmdb
export PYBUILD_DISABLE=test

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/watch ===
version=4

https://github.com/crossbario/zlmdb/tags (?:.*?/)?v(\d[\d.]*)\.tar\.gz
